DROP TABLE IF EXISTS IDP_BASE_TABLE;
CREATE TABLE IDP_BASE_TABLE (
            NAME VARCHAR(20),
            PRIMARY KEY (NAME)
);

INSERT INTO IDP_BASE_TABLE values ('IdP');

DROP TABLE IF EXISTS UM_TENANT_IDP;
DROP SEQUENCE IF EXISTS UM_TENANT_IDP_PK_SEQ;
CREATE SEQUENCE UM_TENANT_IDP_PK_SEQ;
CREATE TABLE UM_TENANT_IDP (
			UM_ID INTEGER DEFAULT NEXTVAL('UM_TENANT_IDP_PK_SEQ'),
			UM_TENANT_ID INTEGER,
			UM_TENANT_IDP_ISSUER VARCHAR(512),
			UM_TENANT_IDP_NAME VARCHAR(512),
            		UM_TENANT_IDP_URL VARCHAR(2048),
			UM_TENANT_IDP_THUMBPRINT VARCHAR(2048),
			UM_TENANT_IDP_PRIMARY CHAR(1) NOT NULL,
			PRIMARY KEY (UM_ID),
			CONSTRAINT CON_IDP_KEY UNIQUE (UM_TENANT_ID, UM_TENANT_IDP_NAME));

DROP TABLE IF EXISTS UM_TENANT_IDP_ROLES;
DROP SEQUENCE IF EXISTS UM_TENANT_IDP_ROLES_PK_SEQ;
CREATE SEQUENCE UM_TENANT_IDP_ROLES_PK_SEQ;
CREATE TABLE UM_TENANT_IDP_ROLES (
			UM_ID INTEGER DEFAULT NEXTVAL('UM_TENANT_IDP_ROLES_PK_SEQ'),
			UM_TENANT_IDP_ID INTEGER,
			UM_TENANT_IDP_ROLE VARCHAR(512),
			PRIMARY KEY (UM_ID),
			CONSTRAINT CON_ROLES_KEY UNIQUE (UM_TENANT_IDP_ID, UM_TENANT_IDP_ROLE),
			FOREIGN KEY (UM_TENANT_IDP_ID) REFERENCES UM_TENANT_IDP(UM_ID) ON DELETE CASCADE);

DROP TABLE IF EXISTS UM_TENANT_IDP_ROLE_MAPPINGS;
DROP SEQUENCE IF EXISTS UM_TENANT_IDP_ROLE_MAPPINGS_PK_SEQ;
CREATE SEQUENCE UM_TENANT_IDP_ROLE_MAPPINGS_PK_SEQ;
CREATE TABLE UM_TENANT_IDP_ROLE_MAPPINGS (
			UM_ID INTEGER DEFAULT NEXTVAL('UM_TENANT_IDP_ROLE_MAPPINGS'),
			UM_TENANT_IDP_ROLE_ID INTEGER,
			UM_TENANT_ID INTEGER,
			UM_TENANT_ROLE VARCHAR(512),	
			PRIMARY KEY (UM_ID),
			CONSTRAINT CON_ROLE_MAPPINGS_KEY UNIQUE (UM_TENANT_IDP_ROLE_ID, UM_TENANT_ID, UM_TENANT_ROLE),
			FOREIGN KEY (UM_TENANT_IDP_ROLE_ID) REFERENCES UM_TENANT_IDP_ROLES(UM_ID) ON DELETE CASCADE);
